# -*- coding: utf-8 -*-
"""This module contains the data model of the application."""


import pkg_resources
pkg_resources.require("SQLAlchemy>=0.4.3")
pkg_resources.require("Elixir>=0.6.1")

# import the basic Elixir classes and functions for declaring the data model
# (see http://elixir.ematia.de/trac/wiki/TutorialDivingIn)
from elixir import Entity, Field, OneToMany, ManyToOne, ManyToMany
from elixir import options_defaults, setup_all
# import some datatypes for table columns from Elixir
# (see http://www.sqlalchemy.org/docs/04/types.html for more)
from elixir import String, Unicode, Integer, DateTime, setup_all
from turbogears.database import get_engine, metadata, session

options_defaults.update(autosetup=False, metadata=metadata, session=session)


# your data model

class Page(Entity):
    pagename = Field(Unicode(30), unique=True)
    data = Field(Unicode)

# let Elixir do the setup

setup_all()

# functions for populating the database

def bootstrap_model(clean=False):
    """Create all database tables and fill them with default data.

    This function is run by the 'bootstrap' function from the command module.
    By default it creates all database tables for your model.

    You can add more functions as you like to add more boostrap data to the
    database or enhance the function below.

    If 'clean' is True, all tables defined by your model will be dropped before
    creating them again.

    """
    create_tables(clean)

def create_tables(drop_all=False):
    """Create all tables defined in the model in the database.

    Optionally drop existing tables before creating them.

    """
    if drop_all:
        print "Dropping all database tables defined in model."
        from elixir import drop_all
        drop_all()
    from elixir import create_all
    create_all()

    print "All database tables defined in model created."

